﻿//
//// mgc1mz.dll  Header Ver1.1600a
//
//   (C) m.magic & K Maruyama.  All rights reserved.
using System;
using System.Runtime.InteropServices;
using System.Text;

namespace mgc1mz
{
    class mmz
    {
        //
        //// 共通
        //

        // 定数
        public const int mzNull = 0;
        public const int maxPath = 260;
        public const int yes = 1;
        public const int no = 0;
        public const int ok = 1;
        public const int cancel = 0;

        // 戻り値
        public const int success = 0;
        public const int failure = -1;
        public const int mzTrue = 1;
        public const int mzFalse = 0;



        //* mmzGetCpuIdentity *//
        // 引数
        public const int dontWriteToFile = mzNull;
        public const int maxLengthForVenderName = 14;
        public const int maxLengthForModelName = 50;
        public const int maxCountForStandard = 64;
        public const int maxCountForExtended = 64;
        // register
        public const int EAX = 0;
        public const int EBX = 1;
        public const int ECX = 2;
        public const int EDX = 3;
        // 3d commands
        public const uint featureMMX = 0x000100;
        public const uint featureMMX_EXT = 0x000200;
        public const uint featureSSE = 0x000400;
        public const uint featureSSE2 = 0x000800;
        public const uint featureSSE3 = 0x001000;
        public const uint featureSSE4p1 = 0x002000;
        public const uint featureSSE4p2 = 0x004000;
        public const uint feature3DNow = 0x000001;
        public const uint feature3DNowPlus = 0x000002;


        public const uint featureSSE4A = 0x000004;
        // Virtual Machine
        public const uint featureAMD_V = 0x010000;
        public const uint featureIntelVT = 0x020000;
        // 64-bit technology available 
        public const uint featureX64 = 0x040000;
        // 戻り値
        public const int errorNotSurppoted = 10000;
        public const int errorFile = -10000;
        public const int errorOutputBuffer = -10001;
        public struct CPUID
        {
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 4)]
            int[] value;
            public void initialize()
            {
                value = new int[4];
            }
        }

        public struct IDENTITY
        {
            public int size;	// size of this structure
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = maxCountForStandard)]
            CPUID[] cidStandard;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = maxCountForExtended)]
            CPUID[] cidExtended;
            public void initialize()
            {
                size = 2056;
                int i;
                cidStandard = new CPUID[maxCountForStandard];
                for (i = 0; i < maxCountForStandard; i++)
                {
                    cidStandard[i].initialize();
                }
                cidExtended = new CPUID[maxCountForExtended];
                for (i = 0; i < maxCountForExtended; i++)
                {
                    cidExtended[i].initialize();
                }
            }
        }
        public struct INFORMATION
        {
            public int size;			// size of this structure
            public float frequency;		// frequency(MHz)
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = maxLengthForVenderName)]
            public string vendorName;	// vendor name
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = maxLengthForModelName)]
            public string modelName;	// name of model
            public int family;			// family of the processor
            public int extendedFamily;	// extended family of the processor
            public int baseFamily;		// base family of the processor
            public int model;			// model of the processor
            public int extendedModel;	// extended model of the processor
            public int baseModel;		// base model of the processor
            public int stepping;		// the processor revision number
            public int cores;			// the processor count 
            public int logicalCores;	// the logical processor count 
            public int threads;		    // Thread count
            public uint feature;		// the processor feature
            public void initialize()
            {
                size = 116;
                frequency = 0.0F;
                vendorName = new string('\0', maxLengthForVenderName);
                modelName = new string('\0', maxLengthForModelName);
                family = extendedFamily = baseFamily = model = extendedModel = 0;
                baseModel = stepping = cores = logicalCores = threads = 0;
                feature = 0;
            }
        }


        //* mmzGetWindowsVersion *//
        public const UInt32 platformWinNT = 2;

        public const UInt32 windowsXpMajor = 5;
        public const UInt32 windowsVistaMajor = 6;
        public const UInt32 windows7Major = 6;
        public const UInt32 windows8Major = 6;
        public const UInt32 windows10Major = 10;

        public const UInt32 windowsXpMinor = 1;
        public const UInt32 windowsVistaMinor = 0;
        public const UInt32 windows7Minor = 1;
        public const UInt32 windows8Minor = 2;
        public const UInt32 windows8p1Minor = 3;
        public const UInt32 windows10Minor = 0;

        public const UInt32 windowsXpRevision = 2600;
        public const UInt32 windowsVistaRevision = 6000;
        public const UInt32 windowsVistaSP1Revision = 6001;
        public const UInt32 windowsVistaSP2Revision = 6002;
        public const UInt32 windows7SP1Revision = 7601;
        public const UInt32 windows8Revision = 9200;
        public const UInt32 windows8p1Revision = 9200;
        public const UInt32 windows8p1Update1Revision = 9600;
        public const UInt32 windows10Revision = 10586;

       
        public struct WINDOWSVERSION
        {
            public UInt32 windowsVersionSize;
            public UInt32 buildNumber;
            public UInt32 majorNumber;
            public UInt32 minorNumber;
            public UInt32 revisionNumber;
            public UInt32 productType;
            public void initialize()
            {
                windowsVersionSize = 24;
            }
        }


        //
        ////  関数定義
        //
        [DllImport("mgc1mz.dll", CharSet = CharSet.Unicode)]
        public static extern int mmzGetIdentity(ref IDENTITY identity, UInt32 time, int fileName);
        [DllImport("mgc1mz.dll", CharSet = CharSet.Unicode)]
        public static extern int mmzGetIdentity(ref IDENTITY identity, UInt32 time, string fileName);
        [DllImport("mgc1mz.dll", CharSet = CharSet.Unicode)]
        public static extern int mmzGetInformation(ref INFORMATION identity, uint time);
        [DllImport("mgc1mz.dll", CharSet = CharSet.Unicode)]
        public static extern void mmzGetWindowsVersion(ref WINDOWSVERSION version);
        [DllImport("mgc1mz.dll", CharSet = CharSet.Unicode)]
        public static extern int mmzIsWow64();
        [DllImport("mgc1mz.dll", CharSet = CharSet.Unicode)]
        public static extern int mmzGetFileVersion(     string fileName,
                                                    ref UInt32 majorNumber,
                                                    ref UInt32 minorNumber,
                                                    ref UInt32 revisionNumber,
                                                    ref UInt32 bildNumber);

        [DllImport("mgc1mz.dll", CharSet = CharSet.Unicode)]
        public static extern int mmzGetTemporaryFileName(int bLongName, StringBuilder fileName, int fileNameLength);

    }
}
