Option Strict On
Option Explicit On

Imports System.Runtime.InteropServices
Imports System.Text


Module mgc1mz
    '//
    '//// mgc1mz.dll Header Ver1.1600a
    '//
    '//   (C) m.magic & K Maruyama.  All rights reserved.

    '//
    '//// 
    '//

    '// 萔
    Public Const mzNull As Integer = 0
    Public Const maxPath As Integer = 260 - 1
    Public Const yes As Integer = 1
    Public Const no As Integer = 0
    Public Const ok As Integer = 1
    Public Const cancel As Integer = 0

    '// ߂l
    Public Const success As Integer = 0
    Public Const failure As Integer = -1
    Public Const mzTrue As Integer = 1
    Public Const mzFalse As Integer = 0



    '//* mmzGetCpuIdentity *//
    '// 
    Public Const dontWriteToFile As Integer = mzNull
    Public Const maxLengthForVenderName As Integer = 14 - 1
    Public Const maxLengthForModelName As Integer = 50 - 1
    Public Const maxCountForStandard As Integer = 64 - 1
    Public Const maxCountForExtended As Integer = 64 - 1
    '// register
    Public Const EAX As Integer = 0
    Public Const EBX As Integer = 1
    Public Const ECX As Integer = 2
    Public Const EDX As Integer = 3
    '// 3d commands
    Public Const featureMMX As UInteger = &H100
    Public Const featureMMX_EXT As UInteger = &H200
    Public Const featureSSE As UInteger = &H400
    Public Const featureSSE2 As UInteger = &H800
    Public Const featureSSE3 As UInteger = &H1000
    Public Const featureSSE4p1 As UInteger = &H2000
    Public Const featureSSE4p2 As UInteger = &H4000
    Public Const feature3DNow As UInteger = &H1
    Public Const feature3DNowPlus As UInteger = &H2


    Public Const featureSSE4A As UInteger = &H4
    '// Virtual Machine
    Public Const featureAMD_V As UInteger = &H10000
    Public Const featureIntelVT As UInteger = &H20000
    '// 64-bit technology available 
    Public Const featureX64 As UInteger = &H40000
    '// ߂l
    Public Const errorNotSurppoted As Integer = 10000
    Public Const errorFile As Integer = -10000
    Public Const errorOutputBuffer As Integer = -10001


    Public Structure CPUID
        <VBFixedArray(3), MarshalAs(UnmanagedType.ByValArray, SizeConst:=4)> _
        Dim value() As Integer
        Public Sub initialize()
            ReDim value(3)
        End Sub
    End Structure

    Public Structure IDENTITY
        Dim size As Integer            '// size of this structure
        <VBFixedArray(maxCountForStandard), _
        MarshalAs(UnmanagedType.ByValArray, SizeConst:=maxCountForStandard + 1)> _
        Dim standard() As CPUID
        <VBFixedArray(maxCountForExtended), _
        MarshalAs(UnmanagedType.ByValArray, SizeConst:=maxCountForExtended + 1)> _
        Dim extended() As CPUID
        Public Sub initialize()
            size = 2052
            Dim i As Integer
            ReDim standard(maxCountForStandard)
            For i = 0 To maxCountForStandard
                standard(i).initialize()
            Next
            ReDim extended(maxCountForExtended)
            For i = 0 To maxCountForExtended
                extended(i).initialize()
            Next
        End Sub
    End Structure

    Public Structure INFORMATION
        Dim size As Integer            '// size of this structure
        Dim frequency As Single        '// frequency(MHz)
        '// vendor name
        <VBFixedString(maxLengthForVenderName), MarshalAs(UnmanagedType.ByValTStr, SizeConst:=maxLengthForVenderName + 1)> _
        Dim vendorName As String
        '// name of model
        <VBFixedString(maxLengthForModelName), MarshalAs(UnmanagedType.ByValTStr, SizeConst:=maxLengthForModelName + 1)> _
        Dim modelName As String
        Dim family As Integer          '// family of the processor
        Dim extendedFamily As Integer  '// extended family of the processor
        Dim baseFamily As Integer      '// base family of the processor
        Dim model As Integer           '// model of the processor
        Dim extendedModel As Integer   '// extended model of the processor
        Dim baseModel As Integer       '// base model of the processor
        Dim stepping As Integer        '// the processor revision number
        Dim cores As Integer           '// the processor count 
        Dim logicalCores As Integer    '// the logical processor count 
        Dim threads As Integer         '// Thread count
        Dim feature As Integer         '// the processor feature
        Sub initialize()
            size = 116
            vendorName = New String(Chr(Asc(" ")), maxLengthForVenderName)
            modelName = New String(Chr(Asc(" ")), maxLengthForModelName)
        End Sub
    End Structure



    '//* mmzGetWindowsVersion *//
    Public uplatformWinNT As Integer = 2

    Public Const windowsXpMajor As Integer = 5
    Public Const windowsVistaMajor As Integer = 6
    Public Const windows7Major As Integer = 6
    Public Const windows8Major As Integer = 6
    Public Const windows10Major As Integer = 10

    Public Const windowsXpMinor As Integer = 1
    Public Const windowsVistaMinor As Integer = 0
    Public Const windows7Minor As Integer = 1
    Public Const windows8Minor As Integer = 2
    Public Const windows8p1Minor As Integer = 3
    Public Const windows10Minor As Integer = 0

    Public Const windowsXpRevision As Integer = 2600
    Public Const windowsVistaRevision As Integer = 6000
    Public Const windowsVistaSP1Revision As Integer = 6001
    Public Const windowsVistaSP2Revision As Integer = 6002
    Public Const windows7SP1Revision As Integer = 7601
    Public Const windows8Revision As Integer = 9200
    Public Const windows8p1Revision As Integer = 9200
    Public Const windows8p1Update1Revision As Integer = 9600
    Public Const windows10Revision As Integer = 10586


    Public Structure WINDOWSVERSION
        Dim windowsVersionSize As Integer
        Dim buildNumber As Integer
        Dim majorNumber As Integer
        Dim minorNumber As Integer
        Dim revisionNumber As Integer
        Dim productType As Integer
        Public Sub initialize()
            windowsVersionSize = 24
        End Sub
    End Structure


    '//
    '////  ֐`
    '//
    Public Declare Unicode Function _
    mmzGetIdentity Lib "mgc1mz.dll" _
    (ByRef identity As IDENTITY, ByVal time As Integer, ByVal fileName As Integer) _
    As Integer
    Public Declare Unicode Function _
    mmzGetIdentity Lib "mgc1mz.dll" _
    (ByRef identity As IDENTITY, ByVal time As Integer, ByVal fileName As String) _
    As Integer
    Public Declare Unicode Function _
    mmzGetInformation Lib "mgc1mz.dll" _
    (ByRef information As INFORMATION, ByVal time As UInteger) _
    As Integer
    Public Declare Unicode Function _
    mmzGetWindowsVersion Lib "mgc1mz.dll" _
    (ByRef version As WINDOWSVERSION) _
    As Integer
    Public Declare Unicode Function _
    mmzIsWow64 Lib "mgc1mz.dll" () _
    As Integer
    Public Declare Unicode Function _
    mmzGetFileVersion Lib "mgc1mz.dll" _
    (ByVal fileName As String, _
     ByRef majorNumber As UInt32, _
     ByRef minorNumber As UInt32, _
     ByRef revisionNumber As UInt32, _
     ByRef bildNumber As UInt32) _
    As Integer

    Public Declare Unicode Function _
    mmzGetTemporaryFileName Lib "mgc1mz.dll" _
    (ByVal longName As Integer, _
     ByVal fileName As StringBuilder, _
     ByVal fileNameLength As Int32) _
    As Integer

End Module
