#pragma once
// CMGC1MZ R}h ^[Qbg
//
//	Ver1.1600a
//
class CMGC1MZ : public CObject
{
public:
	//
	//// 
	//

	// 萔
	static const INT no = FALSE;
	static const INT yes = TRUE;


	// ߂l
	static const INT success = 0;
	static const INT failure = -1;



	//* mmzGetIdentity *//
	// 
	static const INT dontWriteToFile = NULL;
	static const INT maxLengthForVenderName = 14;
	static const INT maxLengthForModelName = 50;
	static const INT maxCountForStandard = 64;
	static const INT maxCountForExtended = 64;
	// register
	static const INT eax = 0;
	static const INT ebx = 1;
	static const INT ecx = 2;
	static const INT edx = 3;
	// 3d commands
	static const UINT futureMMX = 0x000100;
	static const UINT futureMMXextended = 0x000200;
	static const UINT futureSSE = 0x000400;
	static const UINT futureSSE2 = 0x000800;
	static const UINT futureSSE3 = 0x001000;
	static const UINT futureSSE4p1 = 0x002000;
	static const UINT futureSSE4p2 = 0x004000;
	static const UINT future3DNow = 0x000001;
	static const UINT future3DNowExtended = 0x000002;

	// file
	static const ULONG code = 0x000000ff;
	static const ULONG codeOptions = 0xffffff00;

	static const ULONG codeSJIS = 0x00000000;
	static const ULONG codeUTF8 = 0x00000001;
	static const ULONG codeUTF16BE = 0x00000002;
	static const ULONG codeUTF16LE = 0x00000003;
	static const ULONG codeEUC = 0x00000004;
	static const ULONG codeJIS = 0x00000005;	// JIS(ISO2022-JP)	
	
	static const ULONG codeNonBOM = 0x00000100;


	static const UINT futureSSE4A = 0x000004;
	// Virtual Machine
	static const UINT futureAMD_V = 0x010000;
	static const UINT futureIntelVT = 0x020000;
	// 64-bit technology available 
	static const UINT futureX64 = 0x040000;
	// ߂l
	static const INT errorNotSurppoted	 = 10000;
	static const INT errorFile = -10000;
	static const INT errorOutputBuffer = -10001;
	// ^
	typedef struct
	{
		INT nValue[4];
	} CPUID, *LPCPUID;

	typedef struct
	{
		INT		nSize;			// size of this structure
		float	nFrequency;		// frequency(MHz)
		CPUID	cidStandard[maxCountForStandard];
		CPUID	cidExtended[maxCountForExtended];
	} IDENTITY, *LPIDENTITY;


	//* mmzGetInformation *//
	typedef struct
	{
		INT		nSize;								// size of this structure
		FLOAT	nFrequency;							// frequency(MHz)
		CHAR	szVendorName[maxLengthForVenderName];	// vendor name
		CHAR	szModelName[maxLengthForModelName];		// name of model
		INT		nFamily;							// family of the processor
		INT		nExtendedFamily;					// extended family of the processor
		INT		nBaseFamily;						// base family of the processor
		INT		nModel;								// model of the processor
		INT		nExtendedModel;						// extended model of the processor
		INT		nBaseModel;							// base model of the processor
		INT		nStepping;							// the processor revision number
		INT		nCores;								// the processor count 
		INT		nLogicalCores;						// the logical processor count 
		INT		nThreads;							// Thread count
		INT		nFeature;							// the processor feature
	} INFORMATION, *LPINFORMATION;



	// mmzGetWindowsVersion
	static const DWORD platformWinNT = VER_PLATFORM_WIN32_NT;

	static const DWORD windowsXPMajor = 5;
	static const DWORD windowsVistaMajor = 6;
	static const DWORD windows7Major = 6;
	static const DWORD windows8Major = 6;
	static const DWORD windows10Major = 10;

	static const DWORD windowsXPMinor = 1;
	static const DWORD windowsVistaMinor = 0;
	static const DWORD windows7Minor = 1;
	static const DWORD windows8Minor = 2;
	static const DWORD windows8p1Minor = 3;
	static const DWORD windows10Minor = 0;

	static const DWORD windowsXPRevision = 2600;
	static const DWORD windowsVistaRevision = 6000;
	static const DWORD windowsVistaSP1Revision = 6001;
	static const DWORD windowsVistaSP2Revision = 6002;
	static const DWORD windows7SP1Revision = 7601;
	static const DWORD windows8Revision = 9200;
	static const DWORD windows8p1Revision = 9200;
	static const DWORD windows8p1Update1Revision = 9600;
	static const DWORD windows10Revision = 10586;


	typedef struct
	{
		DWORD	dwWIndowsVersionSize;
		DWORD	dwBuildNumber;
		DWORD	dwMajorNumber;
		DWORD	dwMinorNumber;
		DWORD	dwRevisionNumber;
		DWORD	dwProductType;
	} WINDOWSVERSION, *LPWINDOWSVERSION;


public:
	//
	////  ֐`
	//
	typedef INT  (CALLBACK* LPMMZGETIDENTITY) (		LPIDENTITY lpIdentity,
											const	DWORD dwTime,
													LPCWSTR	lpszFileName,
													ULONG nCharacterCode	);
	typedef INT  (CALLBACK* LPMMZGETINFORMATION) (			LPINFORMATION lpInformation,
													const	DWORD dwTime	);
	typedef VOID (CALLBACK* LPMMZGETWINDOWSVERSION) (LPWINDOWSVERSION lpVersion);
	typedef BOOL(CALLBACK* LPMMZISWOW64) ();

	typedef INT(CALLBACK* LPMMZGETFILEVERSION) (	LPCWSTR lpszFile,
													LPDWORD	lpdwMajorNumber,
													LPDWORD	lpdwMinorNumber,
													LPDWORD	lpdwRevisionNumber,
													LPDWORD	lpdwBildNumber	);
	typedef INT(CALLBACK* LPMMZGETTEMPORARYFILENAME) (BOOL bLongName, LPWSTR lpszFileName, INT nFileNameLength);




	LPMMZGETIDENTITY		GetIdentity;
	LPMMZGETINFORMATION		GetInformation;
	LPMMZGETWINDOWSVERSION	GetWindowsVersion;
	LPMMZISWOW64			IsWow64;

	LPMMZGETFILEVERSION			GetFileVersion;
	LPMMZGETTEMPORARYFILENAME	GetTemporaryFileName;

};